package org.jboss.resteasy.resteasy736;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.jboss.resteasy.annotations.Suspend;
import org.jboss.resteasy.spi.AsynchronousResponse;

/**
 *
 * @author <a href="ron.sigal@jboss.com">Ron Sigal</a>
 * @version $Revision: 1.1 $
 *
 * Copyright Aug 15, 2012
 */
@Path("/")
@Produces("text/plain")
public class TestResource
{
   public static final int ASYNC_RESPONSE_TIMEOUT = 5000;
   public static final int CALLED_RESOURCE_EXECUTION_TIME = ASYNC_RESPONSE_TIMEOUT * 2;
   @GET
   @Path("test")
   public void test(final @Suspend(ASYNC_RESPONSE_TIMEOUT) AsynchronousResponse response)
   {
      Thread t = new Thread()
      {
         @Override
         public void run()
         {
            try
            {
               System.out.println("Asynch thread started");
               Thread.sleep(CALLED_RESOURCE_EXECUTION_TIME);
               Response jaxrs = Response.ok("test").type(MediaType.TEXT_PLAIN).build();
               response.setResponse(jaxrs);
               System.out.println("Asynch thread finished");
            }
            catch (Exception e)
            {
               e.printStackTrace();
            }
         }
      };
      t.start();
   }
   @GET
   @Path("testException")
   @Produces("text/plain")
   public void testException(final @Suspend(ASYNC_RESPONSE_TIMEOUT) AsynchronousResponse response) throws Exception {
      //Throw an exception
      throw new RuntimeException("test exception");
   }
}
